/*
 * Created on 2003-7-30
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package dk.eclipse.sablecceditor;


import java.util.List;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.BadPositionCategoryException;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.Position;
import org.eclipse.jface.text.source.ISourceViewer;
import org.eclipse.swt.graphics.Point;
import org.eclipse.ui.texteditor.ITextEditor;
import org.eclipse.ui.texteditor.IUpdate;
import org.eclipse.ui.views.contentoutline.IContentOutlinePage;

/**
 * @author Administrator
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class GotoDeclAction extends Action implements IUpdate{
	/**
	 * A segment element.
	 */
	
	
	private SableccEditor editor=null;
	
	
	
	public GotoDeclAction(ITextEditor editor) {
		super();
		this.editor= (SableccEditor)editor;
		setText("Goto Declaration");
		setToolTipText("goto declaration");
		setDescription("Find Declaration");
		setEnabled(editor!=null);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		
		super.run();
		//IDocumentProvider provider= editor.getDocumentProvider();
		 
			try {
				doRun(editor.getViewer(), editor.getViewer().getDocument());
			}
			catch (Exception e) {
				
				e.printStackTrace();
				
			}
		
	}
	
	public void doRun(ISourceViewer viewer,IDocument document) throws BadPositionCategoryException, BadLocationException {
		
		Point sel= viewer.getSelectedRange();
		String tokenRef= document.get(sel.x, sel.y);
		
		
		
//		Position[] posHelpers= document.getPositions(SableccContentOutlinePage.HELPERS);
//		Position[] posTokens= document.getPositions(SableccContentOutlinePage.TOKENS);
//		Position[] posProds= document.getPositions(SableccContentOutlinePage.PRODUCTIONS);
//		
		SableccContentOutlinePage outline= (SableccContentOutlinePage)editor.getAdapter(IContentOutlinePage.class);
		
		ContentProvider contentProvider=(ContentProvider)outline.getTreeViewer().getContentProvider();
		
		List content= contentProvider.getContent();
		
		//P.xxx 
		Segment prodSeg= getSegment(content, SableccContentOutlinePage.PRODUCTIONS);
		Segment tokSeg= getSegment(content, SableccContentOutlinePage.TOKENS);
		Segment helperSeg= getSegment(content, SableccContentOutlinePage.HELPERS);
		
		Segment enclosing= findEnclosingSegment(document,content, sel.x);
		
		if (tokenRef.startsWith("P.")){
			Position p=getPosition(prodSeg,tokenRef.substring(2));
			if (p!=null){
				editor.setHighlightRange(p.getOffset()+p.getLength()-1,0,true);
				//viewer.setSelectedRange(p.getOffset(),p.getLength());
				
			}
			return;
		}
		
		if (tokenRef.startsWith("T.")){
			Position p=getPosition(tokSeg,tokenRef.substring(2));
			if (p!=null){
				editor.setHighlightRange(p.getOffset()+p.getLength()-1,0,true);
				//viewer.setSelectedRange(p.getOffset(),p.getLength());
				
			}
			return;
		}
		
		
		
		if (enclosing==prodSeg){
			// by default, we first search tokSeg
			Position p=getPosition(tokSeg,tokenRef);
			if (p!=null){
				editor.setHighlightRange(p.getOffset()+p.getLength()-1,0,true);	
			}else {
				p= getPosition(prodSeg,tokenRef);
				if (p!=null)
				editor.setHighlightRange(p.getOffset()+p.getLength()-1,0,true);
			}
		}
		
		if (enclosing==tokSeg){
			//by default search helperSeg
			Position p=getPosition(helperSeg,tokenRef);
			if (p!=null){
				editor.setHighlightRange(p.getOffset()+p.getLength()-1,0,true);	
			}else {
				p= getPosition(tokSeg,tokenRef);
				if (p!=null)
				editor.setHighlightRange(p.getOffset()+p.getLength()-1,0,true);
			}	
		}
		
		if (enclosing==helperSeg){
			Position p=getPosition(helperSeg,tokenRef);
			if (p!=null)
			editor.setHighlightRange(p.getOffset()+p.getLength()-1,0,true);		
		}
		
			
	}
	
	Segment getSegment(List content ,String segName){
		for(int i=0; i<content.size();i++)
		{
			String name=((Segment) content.get(i)).name;
			if ( name.equals(segName) )  {
				return (Segment)content.get(i);
			}
		}
		return null;
	}
	
	Position getPosition(Segment seg, String name){
		for (int i=0; i<seg.details.size();i++)
		{
			Segment aSegment= (Segment)seg.details.get(i);
			if (aSegment.name.equals(name)){
				return aSegment.position;
			}
		}
		return null;
	}
	
	Segment findEnclosingSegment(IDocument document, List content, int x) {
		try {
			int offsetHelpers=Integer.MAX_VALUE;
			int offsetTokens=Integer.MAX_VALUE;
			int offsetProds=Integer.MAX_VALUE;	
			Segment helperPos=getSegment(content,SableccContentOutlinePage.HELPERS);
			Segment tokPos=getSegment(content,SableccContentOutlinePage.TOKENS);
			Segment prodPos=getSegment(content,SableccContentOutlinePage.PRODUCTIONS);
			if (helperPos!=null) offsetHelpers= helperPos.position.getOffset();
			if (tokPos!=null ) offsetTokens= tokPos.position.getOffset();
			if (prodPos!=null) offsetProds= prodPos.position.getOffset();
			
		
		
		if (x>offsetProds)
			return getSegment(content,SableccContentOutlinePage.PRODUCTIONS);
		else if (x>offsetTokens){
			return getSegment(content,SableccContentOutlinePage.TOKENS);
		}else return getSegment(content,SableccContentOutlinePage.HELPERS);
		}catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.texteditor.IUpdate#update()
	 */
	public void update() {
		
		setEnabled(editor!=null);
	}

	public void setEditor(ITextEditor editor) {
		this.editor = (SableccEditor)editor;
	}

	public ITextEditor getEditor() {
		return editor;
	}

}
