/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.sablecc.sablecc2x.lexer;

import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.IOException;
import java.io.PushbackReader;

import org.sablecc.sablecc2x.node.EOF;
import org.sablecc.sablecc2x.node.TArrow;
import org.sablecc.sablecc2x.node.TBar;
import org.sablecc.sablecc2x.node.TBlank;
import org.sablecc.sablecc2x.node.TChar;
import org.sablecc.sablecc2x.node.TColon;
import org.sablecc.sablecc2x.node.TComma;
import org.sablecc.sablecc2x.node.TComment;
import org.sablecc.sablecc2x.node.TDDot;
import org.sablecc.sablecc2x.node.TDecChar;
import org.sablecc.sablecc2x.node.TDot;
import org.sablecc.sablecc2x.node.TEqual;
import org.sablecc.sablecc2x.node.THelpers;
import org.sablecc.sablecc2x.node.THexChar;
import org.sablecc.sablecc2x.node.TId;
import org.sablecc.sablecc2x.node.TIgnored;
import org.sablecc.sablecc2x.node.TLBkt;
import org.sablecc.sablecc2x.node.TLBrace;
import org.sablecc.sablecc2x.node.TLPar;
import org.sablecc.sablecc2x.node.TMinus;
import org.sablecc.sablecc2x.node.TPackage;
import org.sablecc.sablecc2x.node.TPkgId;
import org.sablecc.sablecc2x.node.TPlus;
import org.sablecc.sablecc2x.node.TProductionSpecifier;
import org.sablecc.sablecc2x.node.TProductions;
import org.sablecc.sablecc2x.node.TQMark;
import org.sablecc.sablecc2x.node.TRBkt;
import org.sablecc.sablecc2x.node.TRBrace;
import org.sablecc.sablecc2x.node.TRPar;
import org.sablecc.sablecc2x.node.TSemicolon;
import org.sablecc.sablecc2x.node.TSlash;
import org.sablecc.sablecc2x.node.TStar;
import org.sablecc.sablecc2x.node.TStates;
import org.sablecc.sablecc2x.node.TString;
import org.sablecc.sablecc2x.node.TTokenSpecifier;
import org.sablecc.sablecc2x.node.TTokens;
import org.sablecc.sablecc2x.node.Token;

public class Lexer 
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.PACKAGE; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.PACKAGE; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 11:
                        {
                            Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                            Token token = new12(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 13:
                        {
                            Token token = new13(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 14:
                        {
                            Token token = new14(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 15:
                        {
                            Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 16:
                        {
                            Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 17:
                        {
                            Token token = new17(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 18:
                        {
                            Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 19:
                        {
                            Token token = new19(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 20:
                        {
                            Token token = new20(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 21:
                        {
                            Token token = new21(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 22:
                        {
                            Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 23:
                        {
                            Token token = new23(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 24:
                        {
                            Token token = new24(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 25:
                        {
                            Token token = new25(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 26:
                        {
                            Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 27:
                        {
                            Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 28:
                        {
                            Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 29:
                        {
                            Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 30:
                        {
                            Token token = new30(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 31:
                        {
                            Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 32:
                        {
                            Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 33:
                        {
                            Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 34:
                        {
                            Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(String text, int line, int pos) { return new TPkgId(text, line, pos); }
    Token new1(int line, int pos) { return new TPackage(line, pos); }
    Token new2(int line, int pos) { return new TStates(line, pos); }
    Token new3(int line, int pos) { return new THelpers(line, pos); }
    Token new4(int line, int pos) { return new TTokens(line, pos); }
    Token new5(int line, int pos) { return new TIgnored(line, pos); }
    Token new6(int line, int pos) { return new TProductions(line, pos); }
    Token new7(int line, int pos) { return new TTokenSpecifier(line, pos); }
    Token new8(int line, int pos) { return new TProductionSpecifier(line, pos); }
    Token new9(int line, int pos) { return new TDot(line, pos); }
    Token new10(int line, int pos) { return new TDDot(line, pos); }
    Token new11(int line, int pos) { return new TSemicolon(line, pos); }
    Token new12(int line, int pos) { return new TEqual(line, pos); }
    Token new13(int line, int pos) { return new TLBkt(line, pos); }
    Token new14(int line, int pos) { return new TRBkt(line, pos); }
    Token new15(int line, int pos) { return new TLPar(line, pos); }
    Token new16(int line, int pos) { return new TRPar(line, pos); }
    Token new17(int line, int pos) { return new TLBrace(line, pos); }
    Token new18(int line, int pos) { return new TRBrace(line, pos); }
    Token new19(int line, int pos) { return new TPlus(line, pos); }
    Token new20(int line, int pos) { return new TMinus(line, pos); }
    Token new21(int line, int pos) { return new TQMark(line, pos); }
    Token new22(int line, int pos) { return new TStar(line, pos); }
    Token new23(int line, int pos) { return new TBar(line, pos); }
    Token new24(int line, int pos) { return new TComma(line, pos); }
    Token new25(int line, int pos) { return new TSlash(line, pos); }
    Token new26(int line, int pos) { return new TArrow(line, pos); }
    Token new27(int line, int pos) { return new TColon(line, pos); }
    Token new28(String text, int line, int pos) { return new TId(text, line, pos); }
    Token new29(String text, int line, int pos) { return new TChar(text, line, pos); }
    Token new30(String text, int line, int pos) { return new TDecChar(text, line, pos); }
    Token new31(String text, int line, int pos) { return new THexChar(text, line, pos); }
    Token new32(String text, int line, int pos) { return new TString(text, line, pos); }
    Token new33(String text, int line, int pos) { return new TBlank(text, line, pos); }
    Token new34(String text, int line, int pos) { return new TComment(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {39, 39, 5}, {40, 40, 6}, {41, 41, 7}, {42, 42, 8}, {43, 43, 9}, {44, 44, 10}, {45, 45, 11}, {46, 46, 12}, {47, 47, 13}, {48, 48, 14}, {49, 57, 15}, {58, 58, 16}, {59, 59, 17}, {61, 61, 18}, {63, 63, 19}, {72, 72, 20}, {73, 73, 21}, {80, 80, 22}, {83, 83, 23}, {84, 84, 24}, {91, 91, 25}, {93, 93, 26}, {97, 122, 27}, {123, 123, 28}, {124, 124, 29}, {125, 125, 30}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 9, 1}, {10, 10, 31}, {13, 32, -2}, },
            {{9, 32, -2}, },
            {{0, 9, 32}, {11, 12, 32}, {14, 38, 32}, {39, 39, 33}, {40, 65535, 32}, },
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 34}, },
            {{46, 46, 35}, },
            {{42, 42, 36}, {47, 47, 37}, },
            {{48, 57, 15}, {88, 88, 38}, {120, 120, 39}, },
            {{48, 57, 15}, },
            {},
            {},
            {},
            {},
            {{101, 101, 40}, },
            {{103, 103, 41}, },
            {{97, 97, 42}, {114, 114, 43}, },
            {{116, 116, 44}, },
            {{111, 111, 45}, },
            {},
            {},
            {{48, 57, 46}, {95, 95, 47}, {97, 122, 48}, },
            {},
            {},
            {},
            {{9, 32, -2}, },
            {{0, 9, 49}, {11, 12, 49}, {14, 38, 49}, {39, 39, 50}, {40, 65535, 49}, },
            {{39, 39, 51}, },
            {},
            {},
            {{0, 41, 52}, {42, 42, 53}, {43, 65535, 52}, },
            {{0, 9, 54}, {10, 10, 55}, {11, 12, 54}, {13, 13, 56}, {14, 65535, 54}, },
            {{48, 57, 57}, {65, 70, 57}, {97, 102, 57}, },
            {{48, 102, -40}, },
            {{108, 108, 58}, },
            {{110, 110, 59}, },
            {{99, 99, 60}, },
            {{111, 111, 61}, },
            {{97, 97, 62}, },
            {{107, 107, 63}, },
            {{48, 122, -29}, },
            {{97, 122, 64}, },
            {{48, 122, -29}, },
            {{0, 38, -34}, {39, 39, 65}, {40, 65535, 49}, },
            {},
            {},
            {{0, 65535, -38}, },
            {{0, 41, 66}, {42, 42, 53}, {43, 46, 66}, {47, 47, 67}, {48, 65535, 66}, },
            {{0, 65535, -39}, },
            {},
            {{10, 10, 68}, },
            {{48, 102, -40}, },
            {{112, 112, 69}, },
            {{111, 111, 70}, },
            {{107, 107, 71}, },
            {{100, 100, 72}, },
            {{116, 116, 73}, },
            {{101, 101, 74}, },
            {{48, 57, 75}, {95, 95, 47}, {97, 122, 76}, },
            {},
            {{0, 41, 77}, {42, 42, 78}, {43, 65535, 77}, },
            {},
            {},
            {{101, 101, 79}, },
            {{114, 114, 80}, },
            {{97, 97, 81}, },
            {{117, 117, 82}, },
            {{101, 101, 83}, },
            {{110, 110, 84}, },
            {{48, 122, -66}, },
            {{48, 122, -66}, },
            {{0, 65535, -68}, },
            {{0, 41, 66}, {42, 42, 78}, {43, 65535, -55}, },
            {{114, 114, 85}, },
            {{101, 101, 86}, },
            {{103, 103, 87}, },
            {{99, 99, 88}, },
            {{115, 115, 89}, },
            {{115, 115, 90}, },
            {{115, 115, 91}, },
            {{100, 100, 92}, },
            {{101, 101, 93}, },
            {{116, 116, 94}, },
            {},
            {},
            {},
            {},
            {},
            {{105, 105, 95}, },
            {{111, 111, 96}, },
            {{110, 110, 97}, },
            {{115, 115, 98}, },
            {},
        }
        { // PACKAGE
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {36, 36, 5}, {39, 39, 6}, {40, 40, 7}, {41, 41, 8}, {42, 42, 9}, {43, 43, 10}, {44, 44, 11}, {45, 45, 12}, {46, 46, 13}, {47, 47, 14}, {48, 48, 15}, {49, 57, 16}, {58, 58, 17}, {59, 59, 18}, {61, 61, 19}, {63, 63, 20}, {65, 71, 21}, {72, 72, 22}, {73, 73, 23}, {74, 79, 21}, {80, 80, 24}, {81, 82, 21}, {83, 83, 25}, {84, 84, 26}, {85, 90, 21}, {91, 91, 27}, {93, 93, 28}, {95, 95, 29}, {97, 122, 30}, {123, 123, 31}, {124, 124, 32}, {125, 125, 33}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 9, 1}, {10, 10, 34}, {13, 32, -2}, },
            {{9, 32, -2}, },
            {{36, 36, 35}, {48, 57, 36}, {65, 90, 37}, {95, 95, 38}, {97, 122, 39}, },
            {{0, 9, 40}, {11, 12, 40}, {14, 38, 40}, {39, 39, 41}, {40, 65535, 40}, },
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 42}, },
            {{46, 46, 43}, },
            {{42, 42, 44}, {47, 47, 45}, },
            {{48, 57, 16}, {88, 88, 46}, {120, 120, 47}, },
            {{48, 57, 16}, },
            {},
            {},
            {},
            {},
            {{36, 122, -7}, },
            {{36, 95, -7}, {97, 100, 39}, {101, 101, 48}, {102, 122, 39}, },
            {{36, 95, -7}, {97, 102, 39}, {103, 103, 49}, {104, 122, 39}, },
            {{36, 95, -7}, {97, 113, 39}, {114, 114, 50}, {115, 122, 39}, },
            {{36, 95, -7}, {97, 115, 39}, {116, 116, 51}, {117, 122, 39}, },
            {{36, 95, -7}, {97, 110, 39}, {111, 111, 52}, {112, 122, 39}, },
            {},
            {},
            {{36, 122, -7}, },
            {{36, 36, 35}, {48, 57, 53}, {65, 90, 37}, {95, 95, 54}, {97, 122, 55}, },
            {},
            {},
            {},
            {{9, 32, -2}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{0, 9, 56}, {11, 12, 56}, {14, 38, 56}, {39, 39, 57}, {40, 65535, 56}, },
            {{39, 39, 58}, },
            {},
            {},
            {{0, 41, 59}, {42, 42, 60}, {43, 65535, 59}, },
            {{0, 9, 61}, {10, 10, 62}, {11, 12, 61}, {13, 13, 63}, {14, 65535, 61}, },
            {{48, 57, 64}, {65, 70, 64}, {97, 102, 64}, },
            {{48, 102, -48}, },
            {{36, 95, -7}, {97, 107, 39}, {108, 108, 65}, {109, 122, 39}, },
            {{36, 95, -7}, {97, 109, 39}, {110, 110, 66}, {111, 122, 39}, },
            {{36, 110, -28}, {111, 111, 67}, {112, 122, 39}, },
            {{36, 95, -7}, {97, 97, 68}, {98, 122, 39}, },
            {{36, 95, -7}, {97, 106, 39}, {107, 107, 69}, {108, 122, 39}, },
            {{36, 122, -32}, },
            {{36, 95, -7}, {97, 122, 70}, },
            {{36, 122, -32}, },
            {{0, 38, -42}, {39, 39, 71}, {40, 65535, 56}, },
            {},
            {},
            {{0, 65535, -46}, },
            {{0, 41, 72}, {42, 42, 60}, {43, 46, 72}, {47, 47, 73}, {48, 65535, 72}, },
            {{0, 65535, -47}, },
            {},
            {{10, 10, 74}, },
            {{48, 102, -48}, },
            {{36, 95, -7}, {97, 111, 39}, {112, 112, 75}, {113, 122, 39}, },
            {{36, 110, -28}, {111, 111, 76}, {112, 122, 39}, },
            {{36, 95, -7}, {97, 99, 39}, {100, 100, 77}, {101, 122, 39}, },
            {{36, 115, -27}, {116, 116, 78}, {117, 122, 39}, },
            {{36, 100, -24}, {101, 101, 79}, {102, 122, 39}, },
            {{36, 36, 35}, {48, 57, 80}, {65, 95, -32}, {97, 122, 81}, },
            {},
            {{0, 41, 82}, {42, 42, 83}, {43, 65535, 82}, },
            {},
            {},
            {{36, 100, -24}, {101, 101, 84}, {102, 122, 39}, },
            {{36, 113, -26}, {114, 114, 85}, {115, 122, 39}, },
            {{36, 95, -7}, {97, 116, 39}, {117, 117, 86}, {118, 122, 39}, },
            {{36, 100, -24}, {101, 101, 87}, {102, 122, 39}, },
            {{36, 109, -51}, {110, 110, 88}, {111, 122, 39}, },
            {{36, 122, -72}, },
            {{36, 122, -72}, },
            {{0, 65535, -74}, },
            {{0, 41, 72}, {42, 42, 83}, {43, 65535, -62}, },
            {{36, 113, -26}, {114, 114, 89}, {115, 122, 39}, },
            {{36, 100, -24}, {101, 101, 90}, {102, 122, 39}, },
            {{36, 95, -7}, {97, 98, 39}, {99, 99, 91}, {100, 122, 39}, },
            {{36, 95, -7}, {97, 114, 39}, {115, 115, 92}, {116, 122, 39}, },
            {{36, 114, -89}, {115, 115, 93}, {116, 122, 39}, },
            {{36, 114, -89}, {115, 115, 94}, {116, 122, 39}, },
            {{36, 99, -69}, {100, 100, 95}, {101, 122, 39}, },
            {{36, 115, -27}, {116, 116, 96}, {117, 122, 39}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 95, -7}, {97, 104, 39}, {105, 105, 97}, {106, 122, 39}, },
            {{36, 110, -28}, {111, 111, 98}, {112, 122, 39}, },
            {{36, 109, -51}, {110, 110, 99}, {111, 122, 39}, },
            {{36, 114, -89}, {115, 115, 100}, {116, 122, 39}, },
            {{36, 122, -7}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 33, 33, 33, 33, -1, 15, 16, 22, 19, 24, 20, 9, 25, 30, 30, 27, 11, 12, 21, -1, -1, 8, -1, 7, 13, 14, 28, 17, 23, 18, 33, -1, -1, 26, 10, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 28, -1, 28, -1, 29, 29, -1, -1, -1, 34, 34, 31, -1, -1, -1, -1, -1, -1, 28, 32, -1, 34, 34, -1, -1, -1, -1, -1, -1, 28, 28, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 2, 4, 3, 5, 1, -1, -1, -1, -1, 6, },
        // PACKAGE
        {-1, 33, 33, 33, 33, 0, -1, 15, 16, 22, 19, 24, 20, 9, 25, 30, 30, 27, 11, 12, 21, 0, 0, 0, 0, 0, 0, 13, 14, 0, 0, 17, 23, 18, 33, 0, 0, 0, 0, 0, -1, -1, 26, 10, -1, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, -1, 29, 29, -1, -1, -1, 34, 34, 31, 0, 0, 0, 0, 0, 0, 32, -1, 34, 34, 0, 0, 0, 0, 0, 0, 0, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State PACKAGE = new State(1);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
