/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.sablecc.sablecc2x.tool;

/**/
import java.awt.BorderLayout;
import java.awt.Container;
import java.util.Hashtable;

import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JScrollPane;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;

import org.sablecc.sablecc2x.analysis.DepthFirstAdapter;
import org.sablecc.sablecc2x.node.AAltName;
import org.sablecc.sablecc2x.node.AAlts;
import org.sablecc.sablecc2x.node.AAltsTail;
import org.sablecc.sablecc2x.node.ACharBasic;
import org.sablecc.sablecc2x.node.ACharChar;
import org.sablecc.sablecc2x.node.AConcat;
import org.sablecc.sablecc2x.node.ADecChar;
import org.sablecc.sablecc2x.node.AElem;
import org.sablecc.sablecc2x.node.AElemName;
import org.sablecc.sablecc2x.node.AGrammar;
import org.sablecc.sablecc2x.node.AHelperDef;
import org.sablecc.sablecc2x.node.AHelpers;
import org.sablecc.sablecc2x.node.AHexChar;
import org.sablecc.sablecc2x.node.AIdBasic;
import org.sablecc.sablecc2x.node.AIdList;
import org.sablecc.sablecc2x.node.AIdListTail;
import org.sablecc.sablecc2x.node.AIgnTokens;
import org.sablecc.sablecc2x.node.AIgnoredAlt;
import org.sablecc.sablecc2x.node.AIntervalSet;
import org.sablecc.sablecc2x.node.ALookAhead;
import org.sablecc.sablecc2x.node.AMinusBinOp;
import org.sablecc.sablecc2x.node.AOperationSet;
import org.sablecc.sablecc2x.node.APackage;
import org.sablecc.sablecc2x.node.AParsedAlt;
import org.sablecc.sablecc2x.node.APkgName;
import org.sablecc.sablecc2x.node.APkgNameTail;
import org.sablecc.sablecc2x.node.APlusBinOp;
import org.sablecc.sablecc2x.node.APlusUnOp;
import org.sablecc.sablecc2x.node.AProd;
import org.sablecc.sablecc2x.node.AProductionSpecifier;
import org.sablecc.sablecc2x.node.AProductions;
import org.sablecc.sablecc2x.node.AQMarkUnOp;
import org.sablecc.sablecc2x.node.ARegExp;
import org.sablecc.sablecc2x.node.ARegExpBasic;
import org.sablecc.sablecc2x.node.ARegExpTail;
import org.sablecc.sablecc2x.node.ASetBasic;
import org.sablecc.sablecc2x.node.AStarUnOp;
import org.sablecc.sablecc2x.node.AStateList;
import org.sablecc.sablecc2x.node.AStateListTail;
import org.sablecc.sablecc2x.node.AStates;
import org.sablecc.sablecc2x.node.AStringBasic;
import org.sablecc.sablecc2x.node.ATokenDef;
import org.sablecc.sablecc2x.node.ATokenSpecifier;
import org.sablecc.sablecc2x.node.ATokens;
import org.sablecc.sablecc2x.node.ATransition;
import org.sablecc.sablecc2x.node.AUnExp;
import org.sablecc.sablecc2x.node.Node;
import org.sablecc.sablecc2x.node.PAltsTail;
import org.sablecc.sablecc2x.node.PElem;
import org.sablecc.sablecc2x.node.PHelperDef;
import org.sablecc.sablecc2x.node.PIdListTail;
import org.sablecc.sablecc2x.node.PPkgNameTail;
import org.sablecc.sablecc2x.node.PProd;
import org.sablecc.sablecc2x.node.PRegExpTail;
import org.sablecc.sablecc2x.node.PStateListTail;
import org.sablecc.sablecc2x.node.PTokenDef;
import org.sablecc.sablecc2x.node.PUnExp;


/** 
 * GUI-based display of AST.
 * This is a simple utility that uses Java's JTree class to provide a
 * rudimentary hierarchical display of an AST built by a parser that is 
 * generated by SableCC.  See also PrintTree class.
 *@author Jeffrey Van Baalen
 *@author Mariusz Nowostawski
 */
public class DisplayTree extends DepthFirstAdapter
{

    private Hashtable table = new Hashtable();
    private DefaultMutableTreeNode root = null;

    private String stripName(Node node){
         return node.getClass().getName().substring("org.sablecc.sablecc2x".length()+6);
    }

    // Default node creation.
    public void defaultIn(Node node) 
    {   
        table.put(node, new DefaultMutableTreeNode(stripName(node)));
    }

    public void outAGrammar(AGrammar node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getPackage() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getPackage());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getPackage())+": "+node.getPackage().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getHelpers() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getHelpers());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getHelpers())+": "+node.getHelpers().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getStates() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getStates());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getStates())+": "+node.getStates().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getTokens() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getTokens());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getTokens())+": "+node.getTokens().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getIgnTokens() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getIgnTokens());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getIgnTokens())+": "+node.getIgnTokens().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getProductions() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getProductions());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getProductions())+": "+node.getProductions().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAPackage(APackage node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getPackage() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getPackage());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getPackage())+": "+node.getPackage().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getPkgName() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getPkgName());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getPkgName())+": "+node.getPkgName().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAPkgName(APkgName node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getPkgId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getPkgId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getPkgId())+": "+node.getPkgId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        {
            Object temp[] = node.getPkgIds().toArray();
            for(int i = 0; i < temp.length; i++) 
            {
                if(temp[i]!=null) dnode.add((DefaultMutableTreeNode)table.get((PPkgNameTail) temp[i]));
            }
        }
        if(node.getSemicolon() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSemicolon());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSemicolon())+": "+node.getSemicolon().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAPkgNameTail(APkgNameTail node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getDot() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getDot());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getDot())+": "+node.getDot().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getPkgId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getPkgId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getPkgId())+": "+node.getPkgId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAHelpers(AHelpers node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getHelpers() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getHelpers());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getHelpers())+": "+node.getHelpers().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        {
            Object temp[] = node.getHelperDefs().toArray();
            for(int i = 0; i < temp.length; i++) 
            {
                if(temp[i]!=null) dnode.add((DefaultMutableTreeNode)table.get((PHelperDef) temp[i]));
            }
        }
    }

    public void outAHelperDef(AHelperDef node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getEqual() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getEqual());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getEqual())+": "+node.getEqual().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRegExp() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRegExp());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRegExp())+": "+node.getRegExp().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getSemicolon() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSemicolon());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSemicolon())+": "+node.getSemicolon().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAStates(AStates node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getStates() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getStates());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getStates())+": "+node.getStates().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getIdList() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getIdList());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getIdList())+": "+node.getIdList().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getSemicolon() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSemicolon());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSemicolon())+": "+node.getSemicolon().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAIdList(AIdList node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        {
            Object temp[] = node.getIds().toArray();
            for(int i = 0; i < temp.length; i++) 
            {
                if(temp[i]!=null) dnode.add((DefaultMutableTreeNode)table.get((PIdListTail) temp[i]));
            }
        }
    }

    public void outAIdListTail(AIdListTail node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getComma() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getComma());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getComma())+": "+node.getComma().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outATokens(ATokens node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getTokens() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getTokens());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getTokens())+": "+node.getTokens().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        {
            Object temp[] = node.getTokenDefs().toArray();
            for(int i = 0; i < temp.length; i++) 
            {
                if(temp[i]!=null) dnode.add((DefaultMutableTreeNode)table.get((PTokenDef) temp[i]));
            }
        }
    }

    public void outATokenDef(ATokenDef node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getStateList() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getStateList());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getStateList())+": "+node.getStateList().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getEqual() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getEqual());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getEqual())+": "+node.getEqual().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRegExp() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRegExp());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRegExp())+": "+node.getRegExp().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getLookAhead() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLookAhead());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLookAhead())+": "+node.getLookAhead().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getSemicolon() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSemicolon());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSemicolon())+": "+node.getSemicolon().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAStateList(AStateList node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getLBrace() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLBrace());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLBrace())+": "+node.getLBrace().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getTransition() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getTransition());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getTransition())+": "+node.getTransition().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        {
            Object temp[] = node.getStateLists().toArray();
            for(int i = 0; i < temp.length; i++) 
            {
                if(temp[i]!=null) dnode.add((DefaultMutableTreeNode)table.get((PStateListTail) temp[i]));
            }
        }
        if(node.getRBrace() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRBrace());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRBrace())+": "+node.getRBrace().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAStateListTail(AStateListTail node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getComma() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getComma());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getComma())+": "+node.getComma().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getTransition() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getTransition());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getTransition())+": "+node.getTransition().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outATransition(ATransition node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getArrow() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getArrow());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getArrow())+": "+node.getArrow().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAIgnTokens(AIgnTokens node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getIgnored() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getIgnored());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getIgnored())+": "+node.getIgnored().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getTokens() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getTokens());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getTokens())+": "+node.getTokens().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getIdList() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getIdList());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getIdList())+": "+node.getIdList().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getSemicolon() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSemicolon());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSemicolon())+": "+node.getSemicolon().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outALookAhead(ALookAhead node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getSlash() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSlash());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSlash())+": "+node.getSlash().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRegExp() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRegExp());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRegExp())+": "+node.getRegExp().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outARegExp(ARegExp node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getConcat() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getConcat());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getConcat())+": "+node.getConcat().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        {
            Object temp[] = node.getConcats().toArray();
            for(int i = 0; i < temp.length; i++) 
            {
                if(temp[i]!=null) dnode.add((DefaultMutableTreeNode)table.get((PRegExpTail) temp[i]));
            }
        }
    }

    public void outARegExpTail(ARegExpTail node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getBar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getBar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getBar())+": "+node.getBar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getConcat() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getConcat());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getConcat())+": "+node.getConcat().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAConcat(AConcat node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        {
            Object temp[] = node.getUnExps().toArray();
            for(int i = 0; i < temp.length; i++) 
            {
                if(temp[i]!=null) dnode.add((DefaultMutableTreeNode)table.get((PUnExp) temp[i]));
            }
        }
    }

    public void outAUnExp(AUnExp node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getBasic() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getBasic());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getBasic())+": "+node.getBasic().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getUnOp() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getUnOp());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getUnOp())+": "+node.getUnOp().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outACharBasic(ACharBasic node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getChar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getChar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getChar())+": "+node.getChar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outASetBasic(ASetBasic node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getSet() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSet());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSet())+": "+node.getSet().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAStringBasic(AStringBasic node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getString() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getString());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getString())+": "+node.getString().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAIdBasic(AIdBasic node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outARegExpBasic(ARegExpBasic node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getLPar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLPar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLPar())+": "+node.getLPar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRegExp() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRegExp());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRegExp())+": "+node.getRegExp().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRPar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRPar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRPar())+": "+node.getRPar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outACharChar(ACharChar node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getChar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getChar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getChar())+": "+node.getChar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outADecChar(ADecChar node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getDecChar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getDecChar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getDecChar())+": "+node.getDecChar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAHexChar(AHexChar node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getHexChar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getHexChar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getHexChar())+": "+node.getHexChar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAOperationSet(AOperationSet node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getLBkt() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLBkt());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLBkt())+": "+node.getLBkt().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getLeft() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLeft());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLeft())+": "+node.getLeft().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getBinOp() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getBinOp());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getBinOp())+": "+node.getBinOp().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRight() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRight());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRight())+": "+node.getRight().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRBkt() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRBkt());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRBkt())+": "+node.getRBkt().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAIntervalSet(AIntervalSet node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getLBkt() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLBkt());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLBkt())+": "+node.getLBkt().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getLeft() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLeft());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLeft())+": "+node.getLeft().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getDDot() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getDDot());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getDDot())+": "+node.getDDot().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRight() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRight());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRight())+": "+node.getRight().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRBkt() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRBkt());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRBkt())+": "+node.getRBkt().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAStarUnOp(AStarUnOp node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getStar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getStar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getStar())+": "+node.getStar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAQMarkUnOp(AQMarkUnOp node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getQMark() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getQMark());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getQMark())+": "+node.getQMark().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAPlusUnOp(APlusUnOp node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getPlus() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getPlus());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getPlus())+": "+node.getPlus().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAPlusBinOp(APlusBinOp node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getPlus() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getPlus());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getPlus())+": "+node.getPlus().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAMinusBinOp(AMinusBinOp node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getMinus() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getMinus());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getMinus())+": "+node.getMinus().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAProductions(AProductions node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getProductions() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getProductions());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getProductions())+": "+node.getProductions().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        {
            Object temp[] = node.getProds().toArray();
            for(int i = 0; i < temp.length; i++) 
            {
                if(temp[i]!=null) dnode.add((DefaultMutableTreeNode)table.get((PProd) temp[i]));
            }
        }
    }

    public void outAProd(AProd node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getEqual() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getEqual());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getEqual())+": "+node.getEqual().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getAlts() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getAlts());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getAlts())+": "+node.getAlts().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getSemicolon() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSemicolon());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSemicolon())+": "+node.getSemicolon().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAAlts(AAlts node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getAlt() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getAlt());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getAlt())+": "+node.getAlt().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        {
            Object temp[] = node.getAlts().toArray();
            for(int i = 0; i < temp.length; i++) 
            {
                if(temp[i]!=null) dnode.add((DefaultMutableTreeNode)table.get((PAltsTail) temp[i]));
            }
        }
    }

    public void outAAltsTail(AAltsTail node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getBar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getBar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getBar())+": "+node.getBar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getAlt() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getAlt());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getAlt())+": "+node.getAlt().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAParsedAlt(AParsedAlt node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getAltName() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getAltName());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getAltName())+": "+node.getAltName().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        {
            Object temp[] = node.getElems().toArray();
            for(int i = 0; i < temp.length; i++) 
            {
                if(temp[i]!=null) dnode.add((DefaultMutableTreeNode)table.get((PElem) temp[i]));
            }
        }
    }

    public void outAIgnoredAlt(AIgnoredAlt node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getLPar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLPar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLPar())+": "+node.getLPar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getAltName() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getAltName());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getAltName())+": "+node.getAltName().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        {
            Object temp[] = node.getElems().toArray();
            for(int i = 0; i < temp.length; i++) 
            {
                if(temp[i]!=null) dnode.add((DefaultMutableTreeNode)table.get((PElem) temp[i]));
            }
        }
        if(node.getRPar() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRPar());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRPar())+": "+node.getRPar().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAAltName(AAltName node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getLBrace() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLBrace());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLBrace())+": "+node.getLBrace().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRBrace() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRBrace());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRBrace())+": "+node.getRBrace().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAElem(AElem node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getElemName() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getElemName());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getElemName())+": "+node.getElemName().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getSpecifier() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getSpecifier());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getSpecifier())+": "+node.getSpecifier().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getUnOp() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getUnOp());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getUnOp())+": "+node.getUnOp().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAElemName(AElemName node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getLBkt() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getLBkt());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getLBkt())+": "+node.getLBkt().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getId() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getId());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getId())+": "+node.getId().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getRBkt() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getRBkt());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getRBkt())+": "+node.getRBkt().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getColon() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getColon());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getColon())+": "+node.getColon().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outATokenSpecifier(ATokenSpecifier node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getTokenSpecifier() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getTokenSpecifier());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getTokenSpecifier())+": "+node.getTokenSpecifier().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getDot() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getDot());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getDot())+": "+node.getDot().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public void outAProductionSpecifier(AProductionSpecifier node)
    {
        root =  (DefaultMutableTreeNode)table.get(node);
        DefaultMutableTreeNode dnode = root;
        if(node.getProductionSpecifier() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getProductionSpecifier());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getProductionSpecifier())+": "+node.getProductionSpecifier().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
        if(node.getDot() != null) 
        {
            DefaultMutableTreeNode n = (DefaultMutableTreeNode)table.get(node.getDot());
            if(n == null )
            {
                dnode.add(new DefaultMutableTreeNode(stripName(node.getDot())+": "+node.getDot().toString()));
            } 
            else 
            {
                dnode.add(n);
            }
        }
    }

    public TreeFrame getTreeFrame() 
    {
        return new TreeFrame("Abstract Syntax Tree", root);
    }

    public TreeInternalFrame getTreeInternalFrame() 
    {
        return new TreeInternalFrame("Abstract Syntax Tree", root);
    }

    public static class TreeFrame extends JFrame
    {
        public TreeFrame(String title, DefaultMutableTreeNode root)
        {
            super(title);
            //WindowUtilities.setNativeLookAndFeel();
            Container content = getContentPane();
            JTree tree = new JTree(root);
            content.add(new JScrollPane(tree), BorderLayout.CENTER);
            setSize(275, 300);
        }

    }//TreeFrame


    public static class TreeInternalFrame extends JInternalFrame 
    {
        public TreeInternalFrame(String title, DefaultMutableTreeNode root)
        {
            super(title);
            Container content = getContentPane();
            JTree tree = new JTree(root);
            content.add(new JScrollPane(tree), BorderLayout.CENTER);
            setSize(275, 300);
         }

    }//TreeInternalFrame

}//DisplayTree
