/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.sablecc.sablecc2x.tool;

/**/
import java.io.BufferedReader;
import java.io.IOException;
import java.io.PushbackReader;
import java.io.Reader;
import java.io.StringReader;

import org.sablecc.sablecc2x.lexer.Lexer;
import org.sablecc.sablecc2x.lexer.LexerException;
import org.sablecc.sablecc2x.node.Node;
import org.sablecc.sablecc2x.parser.Parser;
import org.sablecc.sablecc2x.parser.ParserException;

/**
 * Generic parser utility API, Node builder. This class is not really a
 * builder (in terms of Builder pattern), while the result can be
 * collected directly from it. This builder will parse the input (string, stream) 
 * and create Abstract Syntax Tree, via set of utility methods.
 *@author Mariusz Nowostawski
 */
public class TreeBuilder {

  public static Node getNode(final Reader r)
    throws IOException, LexerException, ParserException {
    return getNode(new PushbackReader(r));
  }
  
  public static Node getNode(final StringBuffer text)
    throws IOException, LexerException, ParserException {
    return getNode(text.toString());
  }

  public synchronized static Node getNode(final String text)
    throws IOException, LexerException, ParserException {
    return getNode(new PushbackReader
      (new BufferedReader
        (new StringReader(text))));
  }
  
  public synchronized static Node getNode(final PushbackReader r)
    throws IOException, LexerException, ParserException {
    Lexer lexer = new Lexer(r);
    Parser parser = new Parser(lexer);
    Node ast = parser.parse();
    return ast;
  }
  
} //TreeBuilder
